Index: t3lib/config_default.php
===================================================================
--- t3lib/config_default.php	(Revision 6107)
+++ t3lib/config_default.php	(Arbeitskopie)
@@ -243,6 +243,7 @@
 		'notificationPrefix' => '[TYPO3 Note]',	// String: Used to prefix the subject of mails sent in the taskcenter
 		'accessListRenderMode' => 'singlebox',	// Can be "singlebox", "checkbox" or blank. Refers to the "renderMode" for the selector boxes in be-groups configuration.
 		'explicitADmode' => 'explicitDeny',	// Sets the general allow/deny mode for selector box values. Value can be either "explicitAllow" or "explicitDeny", nothing else!
+		'TSconfigConditions' => 0,			// Boolean. When set it is possible to have TypoScript like conditions in BE Page/User/Group TS-Config
 		'niceFlexFormXMLtags' => TRUE,			// If set, the flexform XML will be stored with meaningful tags which can be validated with DTD schema. If you rely on custom reading of the XML from pre-4.0 versions you should set this to false if you don't like to change your reader code (internally it is insignificant since t3lib_div::xml2array() doesn't care for the tags if the index-attribute value is set)
 		'flexFormXMLincludeDiffBase' => TRUE,	// If set, an additional tag with index "vXX.vDEFbase" is created for translations in flexforms holding the value of the default language when translation was changed. Used to show diff of value. This setting will change whether the system thinks flexform XML looks clean. For example when FALSE XX.vDEFbase fields will be removed in cleaning while accepted if TRUE (of course)
 		'compactFlexFormXML' => 0,				// If set, the flexform XML will not contain indentation spaces making XML more compact
Index: t3lib/class.t3lib_tstemplate.php
===================================================================
--- t3lib/class.t3lib_tstemplate.php	(Revision 6107)
+++ t3lib/class.t3lib_tstemplate.php	(Arbeitskopie)
@@ -293,8 +293,10 @@
 	 */
 	function matching($cc)	{
 		if (is_array($cc['all']))	{
-			$matchObj = t3lib_div::makeInstance('t3lib_matchCondition');
-			$matchObj->altRootLine=$cc['rootLine'];
+			/* @var $matchObj t3lib_matchCondition_frontend */
+			$matchObj = t3lib_div::makeInstance('t3lib_matchCondition_frontend');
+			$matchObj->setRootline((array)$cc['rootLine']);
+			$matchObj->setPageId($GLOBALS['TSFE']->id);
 			foreach ($cc['all'] as $key => $pre) {
 				if ($matchObj->match($pre))	{
 					$sectionsMatch[$key]=$pre;
@@ -809,10 +811,14 @@
 		$constants->breakPointLN=intval($this->ext_constants_BRP);
 		$constants->setup = $this->const;
 		$constants->setup = $this->mergeConstantsFromPageTSconfig($constants->setup);
-		$matchObj = t3lib_div::makeInstance('t3lib_matchCondition');
-		$matchObj->matchAlternative = $this->matchAlternative;
-		$matchObj->matchAll = $this->matchAll;		// Matches ALL conditions in TypoScript
 
+		/* @var $matchObj t3lib_matchCondition_frontend */
+		$matchObj = t3lib_div::makeInstance('t3lib_matchCondition_frontend');
+		$matchObj->setSimulateMatchConditions($this->matchAlternative);
+		if ($this->matchAll) {
+			$matchObj->setSimulateMatchResult(true);
+		}
+
 			// Traverse constants text fields and parse them
 		foreach($this->constants as $str)	{
 			$constants->parse($str,$matchObj);
Index: t3lib/class.t3lib_tsparser_tsconfig.php
===================================================================
--- t3lib/class.t3lib_tsparser_tsconfig.php	(Revision 0)
+++ t3lib/class.t3lib_tsparser_tsconfig.php	(Revision 0)
@@ -0,0 +1,210 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 1999-2007 Kasper Skaarhoj (kasperYYYY@typo3.com)
+*  (c) 2007 Kraft Bernhard (kraftb@kraftb.at)
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+/**
+ * A TS-Config parsing class which performs condition evaluation
+ *
+ * $Id$
+ *
+ * @author	Kraft Bernhard <kraftb@kraftb.at>
+ */
+/**
+ * [CLASS/FUNCTION INDEX of SCRIPT]
+ */
+
+class t3lib_TSparser_TSconfig extends t3lib_TSparser {
+	/**
+	 * Parses the passed TS-Config using conditions and caching
+	 *
+	 * @param	integer	The uid of the page being handled
+	 * @param	array	The rootline of the page being handled
+	 * @param	string	The TSConfig being parsed
+	 * @param	string	The type of TSConfig (either "userTS" or "PAGES")
+	 * @return	array	Array containing the parsed TSConfig and a flag wheter the content was retrieved from cache
+	 * @access private
+	 * @see t3lib_TSparser
+	 */
+	public function parseTSconfig($TStext, $id, $rootLine, $type) {
+		$this->type = $type;
+		$this->id = $id;
+		$this->rootLine = $rootLine;
+		$hash = md5($type.':'.$TStext);
+		$cachedContent = $this->getHash($hash, 0);
+
+		if ($cachedContent) {
+			$storedData = unserialize($cachedContent);
+			$storedMD5 = substr($cachedContent, -strlen($hash));
+			$storedData['match'] = array();
+			$storedData = $this->matching($storedData);
+			$checkMD5 = md5(serialize($storedData));
+
+			if ($checkMD5 == $storedMD5) {
+				$res = array(
+					'TSconfig' => $storedData['TSconfig'],
+					'cached' => 1,
+				);
+			} else {
+				$shash = md5($checkMD5.$hash);
+				$cachedSpec = $this->getHash($shash, 0);
+				if ($cachedSpec) {
+					$storedData = unserialize($cachedSpec);
+					$res = array(
+						'TSconfig' => $storedData['TSconfig'],
+						'cached' => 1,
+					);
+				} else {
+					$storeData = $this->parseWithConditions($TStext);
+					$serData = serialize($storeData);
+					$this->storeHash($shash, $serData, $type.'_TSconfig');
+					$res = array(
+						'TSconfig' => $storeData['TSconfig'],
+						'cached' => 0,
+					);
+				}
+			}
+		} else {
+			$storeData = $this->parseWithConditions($TStext);
+			$serData = serialize($storeData);
+			$md5 = md5($serData);
+			$this->storeHash($hash, $serData.$md5, $type.'_TSconfig');
+			$res = array(
+				'TSconfig' => $storeData['TSconfig'],
+				'cached' => 0,
+			);
+		}
+		return $res;
+	}
+
+
+	/**
+	 * Retrieves the string content stored with hash key, $hash, in cache_hash
+	 * Wrapper to the functions by same name found in t3lib_page and t3lib_BEfunc
+	 * Usage: 1
+	 *
+	 * @param	string		Hash key, 32 bytes hex
+	 * @param	integer		$expTime represents the expire time in seconds. For instance a value of 3600 would allow cached content within the last hour, otherwise nothing is returned.
+	 * @return	string
+	 * @see t3lib_page::getHash()
+	 * @see t3lib_befunc::getHash()
+	 */
+	protected function getHash($hash, $expTime) {
+		if (TYPO3_MODE=='BE') {
+			return t3lib_BEfunc::getHash($hash, $expTime);
+		} elseif (TYPO3_MODE=='FE') {
+			if ($GLOBALS['TSFE']->sys_page) {
+					// After initialization of sys_page
+				return $GLOBALS['TSFE']->sys_page->getHash($hash, $expTime);
+			} else {
+					// When BE user is logged in while viewing frontend (FE-Editing) we have to use the t3lib_BEfunc
+					// method before TSFE->sys_page is initialized
+				return t3lib_BEfunc::getHash($hash, $expTime);
+			}
+		}
+	}
+
+
+	/**
+	 * Stores the string value $data in the 'cache_hash' table with the hash key, $hash, and visual/symbolic identification, $ident
+	 * Wrapper to the functions by same name found in t3lib_page and t3lib_BEfunc
+	 * Usage: 1
+	 *
+	 * @param	string		32 bit hash string (eg. a md5 hash of a serialized array identifying the data being stored)
+	 * @param	string		The data string. If you want to store an array, then just serialize it first.
+	 * @param	string		$ident is just a textual identification in order to inform about the content! May be 20 characters long.
+	 * @return	void
+	 * @see t3lib_page::storeHash()
+	 * @see t3lib_befunc::storeHash()
+	 */
+	protected function storeHash($hash, $data, $ident) {
+		if (TYPO3_MODE=='BE') {
+			t3lib_BEfunc::storeHash($hash, $data, $ident);
+		} elseif (TYPO3_MODE=='FE') {
+			if ($GLOBALS['TSFE']->sys_page) {
+					// After initialization of sys_page
+				$GLOBALS['TSFE']->sys_page->storeHash($hash, $data, $ident);
+			} else {
+					// When BE user is logged in while viewing frontend (FE-Editing) we have to use the t3lib_BEfunc
+					// method before TSFE->sys_page is initialized
+				t3lib_BEfunc::storeHash($hash, $data, $ident);
+			}
+		}
+	}
+
+
+	/**
+	 * Does the actual parsing using the parent objects "parse" method. Creates the match-Object
+	 *
+	 * @param	string	The TSConfig being parsed
+	 * @return	array	Array containing the parsed TSConfig, the encountered sectiosn, the matched sections
+	 * @access private
+	 */
+	protected function parseWithConditions($TSconfig) {
+		/* @var $matchObj t3lib_matchCondition_backend */
+		$matchObj = t3lib_div::makeInstance('t3lib_matchCondition_backend');
+		$matchObj->setRootline($this->rootline);
+		$matchObj->setPageId($this->id);
+
+		$this->parse($TSconfig, $matchObj);
+		$storeData = array(
+			'TSconfig' => $this->setup,
+			'sections' => $this->sections,
+			'match' => $this->sectionsMatch,
+		);
+		return $storeData;
+	}
+
+
+	/**
+	 * Is just going through an array of conditions to determine which are matching (for getting correct cache entry)
+	 *
+	 * @param	array	An array containing the sectiosn to match
+	 * @return	array	The input array with matching sections filled into the "match" key
+	 * @access private
+	 */
+	protected function matching($cc) {
+		if (is_array($cc['sections'])) {
+			/* @var $matchObj t3lib_matchCondition_backend */
+			$matchObj = t3lib_div::makeInstance('t3lib_matchCondition_backend');
+			$matchObj->setRootline($this->rootline);
+			$matchObj->setPageId($this->id);
+
+			foreach ($cc['sections'] as $key => $pre) {
+				if ($matchObj->match($pre)) {
+					$cc['match'][$key] = $pre;
+				}
+			}
+		}
+		return $cc;
+	}
+
+}
+
+
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_tsparser_tsconfig.php']) {
+	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_tsparser_tsconfig.php']);
+}
+?>
\ No newline at end of file
Index: t3lib/class.t3lib_befunc.php
===================================================================
--- t3lib/class.t3lib_befunc.php	(Revision 6107)
+++ t3lib/class.t3lib_befunc.php	(Arbeitskopie)
@@ -1332,18 +1332,26 @@
 			return $TSdataArray;
 		}
 
-			// Parsing the user TS (or getting from cache)
-		$userTS = implode(chr(10) . '[GLOBAL]' . chr(10), $TSdataArray);
-		$hash = md5('pageTS:'.$userTS);
-		$cachedContent = t3lib_BEfunc::getHash($hash);
-		$TSconfig = array();
-		if (isset($cachedContent)) {
-			$TSconfig = unserialize($cachedContent);
+			// Parsing the page TS-Config (or getting from cache)
+		$pageTS = implode(chr(10) . '[GLOBAL]' . chr(10), $TSdataArray);
+		if ($GLOBALS['TYPO3_CONF_VARS']['BE']['TSconfigConditions']) {
+			$parseObj = t3lib_div::makeInstance('t3lib_TSparser_TSconfig');
+			$res = $parseObj->parseTSconfig($pageTS, $id, $rootLine, 'PAGES');
+			if ($res) {
+				$TSconfig = $res['TSconfig'];
+			}
 		} else {
-			$parseObj = t3lib_div::makeInstance('t3lib_TSparser');
-			$parseObj->parse($userTS);
-			$TSconfig = $parseObj->setup;
-			t3lib_BEfunc::storeHash($hash, serialize($TSconfig), 'PAGES_TSconfig');
+			$hash = md5('pageTS:' . $pageTS);
+			$cachedContent = t3lib_BEfunc::getHash($hash);
+			$TSconfig = array();
+			if (isset($cachedContent)) {
+				$TSconfig = unserialize($cachedContent);
+			} else {
+				$parseObj = t3lib_div::makeInstance('t3lib_TSparser');
+				$parseObj->parse($pageTS);
+				$TSconfig = $parseObj->setup;
+				t3lib_BEfunc::storeHash($hash, serialize($TSconfig), 'PAGES_TSconfig');
+			}
 		}
 
 			// get User TSconfig overlay
Index: t3lib/class.t3lib_matchcondition.php
===================================================================
--- t3lib/class.t3lib_matchcondition.php	(Revision 6107)
+++ t3lib/class.t3lib_matchcondition.php	(Arbeitskopie)
@@ -1,642 +0,0 @@
-<?php
-/***************************************************************
-*  Copyright notice
-*
-*  (c) 1999-2009 Kasper Skaarhoj (kasperYYYY@typo3.com)
-*  All rights reserved
-*
-*  This script is part of the TYPO3 project. The TYPO3 project is
-*  free software; you can redistribute it and/or modify
-*  it under the terms of the GNU General Public License as published by
-*  the Free Software Foundation; either version 2 of the License, or
-*  (at your option) any later version.
-*
-*  The GNU General Public License can be found at
-*  http://www.gnu.org/copyleft/gpl.html.
-*  A copy is found in the textfile GPL.txt and important notices to the license
-*  from the author is found in LICENSE.txt distributed with these scripts.
-*
-*
-*  This script is distributed in the hope that it will be useful,
-*  but WITHOUT ANY WARRANTY; without even the implied warranty of
-*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*  GNU General Public License for more details.
-*
-*  This copyright notice MUST APPEAR in all copies of the script!
-***************************************************************/
-/**
- * Contains class for Matching TypoScript conditions
- *
- * $Id$
- * Revised for TYPO3 3.6 July/2003 by Kasper Skaarhoj
- *
- * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
- */
-/**
- * [CLASS/FUNCTION INDEX of SCRIPT]
- *
- *
- *
- *   80: class t3lib_matchCondition
- *   87:     function __construct()
- *  105:     function t3lib_matchCondition()
- *  115:     function match($condition_line)
- *  160:     function evalConditionStr($string)
- *  381:     function testNumber($test,$value)
- *  405:     function matchWild($haystack,$needle)
- *  429:     function whichDevice($useragent)
- *  498:     function browserInfo($useragent)
- *  611:     function browserInfo_version($tmp)
- *  624:     function getGlobal($var, $source=NULL)
- *  658:     function getGP_ENV_TSFE($var)
- *
- * TOTAL FUNCTIONS: 11
- * (This index is automatically created/updated by the extension "extdeveval")
- *
- */
-
-
-
-
-
-
-
-
-
-
-
-
-/**
- * Matching TypoScript conditions
- *
- * Used with the TypoScript parser.
- * Matches browserinfo, IPnumbers for use with templates
- *
- * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
- * @package TYPO3
- * @subpackage t3lib
- * @see t3lib_TStemplate::matching(), t3lib_TStemplate::generateConfig()
- */
-class t3lib_matchCondition {
-	var $matchAlternative=array();		// If this array has elements, the matching returns true if a whole "matchline" is found in the array!
-	var $matchAll=0;					// If set all is matched!
-
-	var $altRootLine=array();
-	var $hookObjectsArr = array();
-
-	/**
-	 * Constructor for this class
-	 *
-	 * @return	void
-	 */
-	function __construct()	{
-		global $TYPO3_CONF_VARS;
-
-		// Usage (ext_localconf.php):
-		// $TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_matchcondition.php']['matchConditionClass'][] =
-		// 'EXT:my_ext/class.browserinfo.php:MyBrowserInfoClass';
-		if (is_array($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_matchcondition.php']['matchConditionClass'])) {
-			foreach ($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_matchcondition.php']['matchConditionClass'] as $classRef) {
-				$this->hookObjectsArr[] = t3lib_div::getUserObj($classRef, '');
-			}
-		}
-	}
-
-	/**
-	 * Constructor for this class
-	 *
-	 * @return	void
-	 */
-	function t3lib_matchCondition() {
-		$this->__construct();
-	}
-
-	/**
-	 * Matching TS condition
-	 *
-	 * @param	string		Line to match
-	 * @return	boolean		True if matched
-	 */
-	function match($condition_line) {
-		if ($this->matchAll) {
-			return true;
-		}
-		if (count($this->matchAlternative))	{
-			return in_array($condition_line, $this->matchAlternative);
-		}
-
-			// Getting the value from inside of the wrapping square brackets of the condition line:
-		$insideSqrBrackets = substr(trim($condition_line), 1, strlen($condition_line) - 2);
-		$insideSqrBrackets = preg_replace('/\]\s*OR\s*\[/i', ']||[', $insideSqrBrackets);
-		$insideSqrBrackets = preg_replace('/\]\s*AND\s*\[/i', ']&&[', $insideSqrBrackets);
-
-			// The "weak" operator "||" (OR) takes precedence: backwards compatible, [XYZ][ZYX] does still work as OR
-		$orParts = preg_split('/\]\s*(\|\|){0,1}\s*\[/',$insideSqrBrackets);
-
-		foreach ($orParts as $partString)	{
-			$matches = false;
-
-				// Splits by the "&&" (AND) operator:
-			$andParts = preg_split('/\]\s*&&\s*\[/',$partString);
-			foreach ($andParts as $condStr)	{
-				$matches = $this->evalConditionStr($condStr);
-				if ($matches===false)	{
-					break;		// only true AND true = true, so we have to break here
-				}
-			}
-
-			if ($matches===true)	{
-				break;		// true OR false = true, so we break if we have a positive result
-			}
-		}
-
-		return $matches;
-	}
-
-
-	/**
-	 * Evaluates a TypoScript condition given as input, eg. "[browser=net][...(other conditions)...]"
-	 *
-	 * @param	string		The condition to match against its criterias.
-	 * @return	boolean		Returns true or false based on the evaluation.
-	 * @see t3lib_tsparser::parse()
-	 * @link http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=270&tx_extrepmgm_pi1[tocEl]=292&cHash=c6c7d43d2f
-	 */
-	function evalConditionStr($string)	{
-		if (!is_array($this->altRootLine)) {
-			$this->altRootLine = array();
-		}
-		list($key, $value) = explode('=', $string, 2);
-		$key = trim($key);
-		$value = trim($value);
-		if (t3lib_div::inList('browser,version,system,useragent', strtolower($key))) {
-			$browserInfo = $this->browserInfo(t3lib_div::getIndpEnv('HTTP_USER_AGENT'));
-		}
-		switch ($key) {
-			case 'browser':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					if (strpos($browserInfo['browser'] . $browserInfo['version'], $test) !== false) {
-						return true;
-					}
-				}
-			break;
-			case 'version':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					if (strcspn($test, '=<>') == 0) {
-						switch (substr($test, 0, 1)) {
-							case '=':
-								if (doubleval(substr($test, 1)) == $browserInfo['version']) {
-									return true;
-								}
-							break;
-							case '<':
-								if (doubleval(substr($test, 1)) > $browserInfo['version']) {
-									return true;
-								}
-							break;
-							case '>':
-								if (doubleval(substr($test, 1)) < $browserInfo['version']) {
-									return true;
-								}
-							break;
-						}
-					} else {
-						if (strpos(' ' . $browserInfo['version'], $test) == 1) {
-							return true;
-						}
-					}
-				}
-			break;
-			case 'system':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					if (strpos(' ' . $browserInfo['system'], $test) == 1) {
-						return true;
-					}
-				}
-			break;
-			case 'device':
-				if (!isset($this->deviceInfo)) {
-					$this->deviceInfo = $this->whichDevice(t3lib_div::getIndpEnv('HTTP_USER_AGENT'));
-				}
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					if ($this->deviceInfo == $test) {
-						return true;
-					}
-				}
-			break;
-			case 'useragent':
-				$test = trim($value);
-				if (strlen($test)) {
-					return $this->matchWild($browserInfo['useragent'], $test);
-				}
-			break;
-			case 'language':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					if (preg_match('/^\*.+\*$/', $test)) {
-						$allLanguages = preg_split('/[,;]/', t3lib_div::getIndpEnv('HTTP_ACCEPT_LANGUAGE'));
-						if (in_array(substr($test, 1, -1), $allLanguages)) {
-							return true;
-						}
-					} else if (t3lib_div::getIndpEnv('HTTP_ACCEPT_LANGUAGE') == $test) {
-						return true;
-					}
-				}
-			break;
-			case 'IP':
-				if (t3lib_div::cmpIP(t3lib_div::getIndpEnv('REMOTE_ADDR'), $value)) {
-					return true;
-				}
-			break;
-			case 'hostname':
-				if (t3lib_div::cmpFQDN(t3lib_div::getIndpEnv('REMOTE_ADDR'), $value)) {
-					return true;
-				}
-			break;
-				// hour, minute, dayofweek, dayofmonth, month, year, julianday
-			case 'hour':
-			case 'minute':
-			case 'month':
-			case 'year':
-			case 'dayofweek':
-			case 'dayofmonth':
-			case 'dayofyear':
-				$theEvalTime = $GLOBALS['SIM_EXEC_TIME'];	// In order to simulate time properly in templates.
-				switch($key) {
-					case 'hour':		$theTestValue = date('H', $theEvalTime);	break;
-					case 'minute':		$theTestValue = date('i', $theEvalTime);	break;
-					case 'month':		$theTestValue = date('m', $theEvalTime);	break;
-					case 'year':		$theTestValue = date('Y', $theEvalTime);	break;
-					case 'dayofweek':	$theTestValue = date('w', $theEvalTime);	break;
-					case 'dayofmonth':	$theTestValue = date('d', $theEvalTime);	break;
-					case 'dayofyear':	$theTestValue = date('z', $theEvalTime);	break;
-				}
-				$theTestValue = intval($theTestValue);
-					// comp
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					if (t3lib_div::testInt($test)) {
-						$test = '=' . $test;
-					}
-					if ($this->testNumber($test, $theTestValue)) {
-						return true;
-					}
-				}
-			break;
-			case 'usergroup':
-				if ($GLOBALS['TSFE']->gr_list != '0,-1') {		// '0,-1' is the default usergroups when not logged in!
-					$values = t3lib_div::trimExplode(',', $value, true);
-					foreach ($values as $test) {
-						if ($test == '*' || t3lib_div::inList($GLOBALS['TSFE']->gr_list, $test)) {
-							return true;
-						}
-					}
-				}
-			break;
-			case 'loginUser':
-				if ($GLOBALS['TSFE']->loginUser) {
-					$values = t3lib_div::trimExplode(',', $value, true);
-					foreach ($values as $test) {
-						if ($test == '*' || !strcmp($GLOBALS['TSFE']->fe_user->user['uid'], $test)) {
-							return true;
-						}
-					}
-				}
-			break;
-			case 'globalVar':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					$point = strcspn($test, '!=<>');
-					$theVarName = substr($test, 0, $point);
-					$nv = $this->getGP_ENV_TSFE(trim($theVarName));
-					$testValue = substr($test, $point);
-
-					if ($this->testNumber($testValue, $nv)) {
-						return true;
-					}
-				}
-			break;
-			case 'globalString':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				foreach ($values as $test) {
-					$point = strcspn($test, '=');
-					$theVarName = substr($test, 0, $point);
-					$nv = $this->getGP_ENV_TSFE(trim($theVarName));
-					$testValue = substr($test, $point+1);
-
-					if ($this->matchWild($nv, trim($testValue))) {
-						return true;
-					}
-				}
-			break;
-			case 'treeLevel':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				$theRootLine = is_array($GLOBALS['TSFE']->tmpl->rootLine) ? $GLOBALS['TSFE']->tmpl->rootLine : $this->altRootLine;
-				$treeLevel = count($theRootLine)-1;
-				foreach ($values as $test) {
-					if ($test == $treeLevel) {
-						return true;
-					}
-				}
-			break;
-			case 'PIDupinRootline':
-			case 'PIDinRootline':
-				$values = t3lib_div::trimExplode(',', $value, true);
-				if (($key=='PIDinRootline') || (!in_array($GLOBALS['TSFE']->id, $values))) {
-					$theRootLine = is_array($GLOBALS['TSFE']->tmpl->rootLine) ? $GLOBALS['TSFE']->tmpl->rootLine : $this->altRootLine;
-					foreach ($values as $test) {
-						foreach ($theRootLine as $rl_dat) {
-							if ($rl_dat['uid'] == $test) {
-								return true;
-							}
-						}
-					}
-				}
-			break;
-			case 'compatVersion':
-				return t3lib_div::compat_version($value);
-			break;
-			case 'userFunc':
-				$values = preg_split('/\(|\)/', $value);
-				$funcName = trim($values[0]);
-				$funcValue = t3lib_div::trimExplode(',', $values[1]);
-				$pre = $GLOBALS['TSFE']->TYPO3_CONF_VARS['FE']['userFuncClassPrefix'];
-				if ($pre &&
-					!t3lib_div::isFirstPartOfStr(trim($funcName),$pre) &&
-					!t3lib_div::isFirstPartOfStr(trim($funcName),'tx_')
-				)	{
-					if (is_object($GLOBALS['TT']))	$GLOBALS['TT']->setTSlogMessage('Match condition: Function "'.$funcName.'" was not prepended with "'.$pre.'"',3);
-					return false;
-				}
-				if (function_exists($funcName) && call_user_func($funcName, $funcValue[0]))	{
-					return true;
-				}
-			break;
-		}
-
-
-		return false;
-	}
-
-	/**
-	 * Evaluates a $leftValue based on an operator: "<", ">", "<=", ">=", "!=" or "="
-	 *
-	 * @param	string		$test: The value to compare with on the form [operator][number]. Eg. "< 123"
-	 * @param	integer		$leftValue: The value on the left side
-	 * @return	boolean		If $value is "50" and $test is "< 123" then it will return true.
-	 */
-	function testNumber($test, $leftValue) {
-		if (preg_match('/^(!?=+|<=?|>=?)\s*([^\s]*)\s*$/', $test, $matches)) {
-			$operator = $matches[1];
-			$rightValue = $matches[2];
-
-			switch ($operator) {
-				case '>=':
-					return ($leftValue >= doubleval($rightValue));
-					break;
-				case '<=':
-					return ($leftValue <= doubleval($rightValue));
-					break;
-				case '!=':
-					return ($leftValue != doubleval($rightValue));
-					break;
-				case '<':
-					return ($leftValue < doubleval($rightValue));
-					break;
-				case '>':
-					return ($leftValue > doubleval($rightValue));
-					break;
-				default:
-					// nothing valid found except '=', use '='
-					return ($leftValue == trim($rightValue));
-					break;
-			}
-		}
-
-		return false;
-	}
-
-	/**
-	 * Matching two strings against each other, supporting a "*" wildcard or (if wrapped in "/") PCRE regular expressions
-	 *
-	 * @param	string		The string in which to find $needle.
-	 * @param	string		The string to find in $haystack
-	 * @return	boolean		Returns true if $needle matches or is found in (according to wildcards) in $haystack. Eg. if $haystack is "Netscape 6.5" and $needle is "Net*" or "Net*ape" then it returns true.
-	 */
-	function matchWild($haystack, $needle) {
-		$result = false;
-
-		if ($needle) {
-			if (preg_match('/^\/.+\/$/', $needle)) {
-				// Regular expression, only "//" is allowed as delimiter
-				$regex = $needle;
-			} else {
-				$needle = str_replace(array('*', '?'), array('###MANY###', '###ONE###'), $needle);
-				$regex = '/^' . preg_quote($needle, '/') . '$/';
-				// Replace the marker with .* to match anything (wildcard)
-				$regex = str_replace(array('###MANY###', '###ONE###'), array('.*' , '.'), $regex);
-			}
-
-			$result = (boolean)preg_match($regex, (string)$haystack);
-		}
-
-		return $result;
-	}
-
-	/**
-	 * Returns a code for a browsing device based on the input useragent string
-	 *
-	 * @param	string		User agent string from browser, t3lib_div::getIndpEnv('HTTP_USER_AGENT')
-	 * @return	string		A code. See link.
-	 * @access private
-	 * @link http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=270&tx_extrepmgm_pi1[tocEl]=296&cHash=a8ae66c7d6
-	 */
-	function whichDevice($useragent)	{
-		foreach($this->hookObjectsArr as $hookObj)	{
-			if (method_exists($hookObj, 'whichDevice')) {
-				$result = $hookObj->whichDevice($useragent);
-				if (strlen($result)) {
-					return $result;
-				}
-			}
-		}
-
-		// deprecated, see above
-		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_matchcondition.php']['devices_class']))	{
-			foreach($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_matchcondition.php']['devices_class'] as $_classRef)	{
-				$_procObj = t3lib_div::getUserObj($_classRef);
-				return $_procObj->whichDevice_ext($useragent);
-			}
-		}
-		//
-
-		$agent=strtolower(trim($useragent));
-			// pda
-		if(	strstr($agent, 'avantgo'))	{
-			return 'pda';
-		}
-
-			// wap
-		$browser=substr($agent,0,4);
-		$wapviwer=substr(stristr($agent,'wap'),0,3);
-		if(	$wapviwer=='wap' ||
-			$browser=='noki' ||
-			$browser== 'eric' ||
-			$browser== 'r380' ||
-			$browser== 'up.b' ||
-			$browser== 'winw' ||
-			$browser== 'wapa')	{
-				return 'wap';
-		}
-
-			// grabber
-		if(	strstr($agent, 'g.r.a.b.') ||
-			strstr($agent, 'utilmind httpget') ||
-			strstr($agent, 'webcapture') ||
-			strstr($agent, 'teleport') ||
-			strstr($agent, 'webcopier'))	{
-			return 'grabber';
-		}
-
-			// robots
-		if(	strstr($agent, 'crawler') ||
-			strstr($agent, 'spider') ||
-			strstr($agent, 'googlebot') ||
-			strstr($agent, 'searchbot') ||
-			strstr($agent, 'infoseek') ||
-			strstr($agent, 'altavista') ||
-			strstr($agent, 'diibot'))	{
-			return 'robot';
-		}
-
-	}
-
-	/**
-	 * Generates an array with abstracted browser information
-	 * This method is used in the function match() in this class
-	 *
-	 * @param	string		The useragent string, t3lib_div::getIndpEnv('HTTP_USER_AGENT')
-	 * @return	array		Contains keys "browser", "version", "system"
-	 * @access private
-	 * @see match()
-	 */
-	function browserInfo($useragent)	{
-		foreach($this->hookObjectsArr as $hookObj)	{
-			if (method_exists($hookObj, 'browserInfo')) {
-				$result = $hookObj->browserInfo($useragent);
-				if (strlen($result)) {
-					return $result;
-				}
-			}
-		}
-
-		$browserInfo = t3lib_utility_Client::getBrowserInfo($useragent);
-
-		return $browserInfo;
-	}
-
-	/**
-	 * Returns the version of a browser; Basically getting doubleval() of the input string, stripping of any non-numeric values in the beginning of the string first.
-	 *
-	 * @param	string		A string with version number, eg. "/7.32 blablabla"
-	 * @return	double		Returns double value, eg. "7.32"
-	 * @deprecated	since TYPO3 4.3 - use t3lib_utility_Client::getVersion() instead
-	 */
-	function browserInfo_version($tmp)	{
-		t3lib_div::logDeprecatedFunction();
-		return t3lib_utility_Client::getVersion($tmp);
-	}
-
-	/**
-	 * Return global variable where the input string $var defines array keys separated by "|"
-	 * Example: $var = "HTTP_SERVER_VARS | something" will return the value $GLOBALS['HTTP_SERVER_VARS']['something'] value
-	 *
-	 * @param	string		Global var key, eg. "HTTP_GET_VAR" or "HTTP_GET_VARS|id" to get the GET parameter "id" back.
-	 * @param	array		Alternative array than $GLOBAL to get variables from.
-	 * @return	mixed		Whatever value. If none, then blank string.
-	 * @access private
-	 */
-	function getGlobal($var, $source=NULL)	{
-		$vars = explode('|',$var);
-		$c = count($vars);
-		$k = trim($vars[0]);
-		$theVar = isset($source) ? $source[$k] : $GLOBALS[$k];
-
-		for ($a=1;$a<$c;$a++)	{
-			if (!isset($theVar))	{ break; }
-
-			$key = trim($vars[$a]);
-			if (is_object($theVar))	{
-				$theVar = $theVar->$key;
-			} elseif (is_array($theVar))	{
-				$theVar = $theVar[$key];
-			} else {
-				return '';
-			}
-		}
-
-		if (!is_array($theVar) && !is_object($theVar))	{
-			return $theVar;
-		} else {
-			return '';
-		}
-	}
-
-	/**
-	 * Returns GP / ENV / TSFE vars
-	 *
-	 * @param	string		Identifier
-	 * @return	mixed		The value of the variable pointed to.
-	 * @access private
-	 * @link http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=270&tx_extrepmgm_pi1[tocEl]=311&cHash=487cbd5cdf
-	 */
-	function getGP_ENV_TSFE($var) {
-		$vars = explode(':',$var,2);
-		if (count($vars)==1)	{
-			$val = $this->getGlobal($var);
-		} else {
-			$splitAgain=explode('|',$vars[1],2);
-			$k=trim($splitAgain[0]);
-			if ($k)	{
-				switch((string)trim($vars[0]))	{
-					case 'GP':
-						$val = t3lib_div::_GP($k);
-					break;
-					case 'TSFE':
-						$val = $this->getGlobal('TSFE|'.$vars[1]);
-						$splitAgain=0;	// getGlobal resolves all parts of the key, so no further splitting is needed
-					break;
-					case 'ENV':
-						$val = getenv($k);
-					break;
-					case 'IENV':
-						$val = t3lib_div::getIndpEnv($k);
-					break;
-					case 'LIT':
-						{ return trim($vars[1]); }	// return litteral value...
-					break;
-				}
-					// If array:
-				if (count($splitAgain)>1)	{
-					if (is_array($val) && trim($splitAgain[1]))	{
-						$val=$this->getGlobal($splitAgain[1],$val);
-					} else {
-						$val='';
-					}
-				}
-			}
-		}
-		return $val;
-	}
-}
-
-
-if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_matchcondition.php'])	{
-	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_matchcondition.php']);
-}
-
-?>
\ No newline at end of file
Index: t3lib/core_autoload.php
===================================================================
--- t3lib/core_autoload.php	(Revision 6107)
+++ t3lib/core_autoload.php	(Arbeitskopie)
@@ -39,6 +39,9 @@
 	't3lib_loadmodules' => PATH_t3lib . 'class.t3lib_loadmodules.php',
 	't3lib_lock' => PATH_t3lib . 'class.t3lib_lock.php',
 	't3lib_matchcondition' => PATH_t3lib . 'class.t3lib_matchcondition.php',
+	't3lib_matchcondition_abstract' => PATH_t3lib . 'matchcondition/class.t3lib_matchcondition_abstract.php',
+	't3lib_matchcondition_backend' => PATH_t3lib . 'matchcondition/class.t3lib_matchcondition_backend.php',
+	't3lib_matchcondition_frontend' => PATH_t3lib . 'matchcondition/class.t3lib_matchcondition_frontend.php',
 	't3lib_modsettings' => PATH_t3lib . 'class.t3lib_modsettings.php',
 	't3lib_pageselect' => PATH_t3lib . 'class.t3lib_page.php',
 	't3lib_pagerenderer' => PATH_t3lib . 'class.t3lib_pagerenderer.php',
@@ -75,6 +78,7 @@
 	't3lib_tsfebeuserauth' => PATH_t3lib . 'class.t3lib_tsfebeuserauth.php',
 	't3lib_tsparser' => PATH_t3lib . 'class.t3lib_tsparser.php',
 	't3lib_tsparser_ext' => PATH_t3lib . 'class.t3lib_tsparser_ext.php',
+	't3lib_tsparser_tsconfig' => PATH_t3lib . 'class.t3lib_tsparser_tsconfig.php',
 	't3lib_tsstyleconfig' => PATH_t3lib . 'class.t3lib_tsstyleconfig.php',
 	't3lib_tstemplate' => PATH_t3lib . 'class.t3lib_tstemplate.php',
 	't3lib_userauth' => PATH_t3lib . 'class.t3lib_userauth.php',
Index: t3lib/matchcondition/class.t3lib_matchcondition_backend.php
===================================================================
--- t3lib/matchcondition/class.t3lib_matchcondition_backend.php	(Revision 0)
+++ t3lib/matchcondition/class.t3lib_matchcondition_backend.php	(Revision 0)
@@ -0,0 +1,279 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 2009 Oliver Hader <oliver@typo3.org>
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+/**
+ * Matching TypoScript conditions for backend disposal.
+ *
+ * Used with the TypoScript parser.
+ * Matches browserinfo, IPnumbers for use with templates
+ *
+ * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
+ * @package TYPO3
+ * @subpackage t3lib
+ */
+class t3lib_matchCondition_backend extends t3lib_matchCondition_abstract {
+	/**
+	 * Constructor for this class
+	 *
+	 * @return	void
+	 */
+	function __construct() {
+	}
+
+	/**
+	 * Sets the id of the page to evaluate conditions for.
+	 *
+	 * @param	integer		$pageId: Id of the page
+	 * @return	void
+	 */
+	public function setPageId($pageId = 0) {
+		if (!(int)$pageId) {
+			$pageId = $this->determinePageId();
+		}
+
+		parent::setPageId($pageId);
+	}
+
+	/**
+	 * Evaluates a TypoScript condition given as input, eg. "[browser=net][...(other conditions)...]"
+	 *
+	 * @param	string		The condition to match against its criterias.
+	 * @return	boolean		Returns true or false based on the evaluation.
+	 * @see t3lib_tsparser::parse()
+	 */
+	protected function evaluateCondition($string) {
+		list($key, $value) = t3lib_div::trimExplode('=', $string, false, 2);
+
+		$result = parent::evaluateConditionCommon($key, $value);
+
+		if (is_bool($result)) {
+			return $result;
+		} else {
+			switch ($key) {
+				case 'treeLevel':
+					// @todo: Behaviour when new page is being created...
+					$values = t3lib_div::trimExplode(',', $value, true);
+					$treeLevel = count($this->rootline) - 1;
+					foreach ($values as $test) {
+						if ($test == $treeLevel) {
+							return true;
+						}
+					}
+				break;
+				case 'PIDupinRootline':
+				case 'PIDinRootline':
+					$values = t3lib_div::trimExplode(',', $value, true);
+					if (($key=='PIDinRootline') || (!in_array($this->pageId, $values)) || $this->isNewPageWithPid($this->pageId)) {
+						foreach ($values as $test) {
+							foreach ($this->rootline as $rl_dat) {
+								if ($rl_dat['uid'] == $test) {
+									return true;
+								}
+							}
+						}
+					}
+				break;
+			}
+		}
+
+		return false;
+	}
+
+	/**
+	 * Returns GP / ENV vars
+	 *
+	 * @param	string		Identifier
+	 * @return	mixed		The value of the variable pointed to.
+	 * @access private
+	 * @link http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=270&tx_extrepmgm_pi1[tocEl]=311&cHash=487cbd5cdf
+	 */
+	protected function getVariable($var) {
+		$vars = explode(':', $var, 2);
+
+		$val = parent::getVariableCommon($vars);
+
+		return $val;
+	}
+
+	/**
+	 * Get the usergroup list of the current user.
+	 *
+	 * @return	string		The usergroup list of the current user
+	 */
+	protected function getGroupList() {
+		$groupList = $GLOBALS['BE_USER']->groupList;
+		return $groupList;
+	}
+
+	/**
+	 * Tries to determine the ID of the page currently processed. User/Group TS-Config is also parsed when no specific
+	 * page is handled (i.e. in the Extension Manager, etc.)
+	 *
+	 * @return	integer		evaluated ID or 0 if none
+	 * @access private
+	 */
+	protected function determinePageId() {
+		$ret = 0;
+		if ($id = intval(t3lib_div::_GP('id'))) {
+			$ret = $id;
+		} elseif ($edit = t3lib_div::_GP('edit')) {
+			list($table, $val) = each($edit);
+			list($uid, $action) = each($val);
+			if ($action=='edit') {
+				if ($table=='pages') {
+					$ret = intval($uid);
+				} else {
+					$rec = t3lib_BEfunc::getRecord($table, $uid);
+					$ret = $rec['pid'];
+				}
+			} elseif ($action=='new') {
+				$ret = intval($uid);
+			}
+		} elseif ($cmd = t3lib_div::_GP('cmd')) {
+			list($table, $val) = each($cmd);
+			list($uid, $val2) = each($val);
+			list($action, $param) = each($val2);
+			if ($action=='delete') {
+				if ($table=='pages') {
+					$ret = intval($uid);
+				} else {
+					$rec = t3lib_BEfunc::getRecord($table, $uid);
+					$ret = $rec['pid'];
+				}
+			} elseif (($action=='copy') || ($action=='move')) {
+				$param = intval($param);
+				if ($param>=0) {
+					$ret = $param;
+				} else {
+					$rec = t3lib_BEfunc::getRecord($table, $uid);
+					$ret = $rec['pid'];
+				}
+			}
+		}
+		return $ret;
+	}
+
+	/**
+	 * Determine if record of table 'pages' with the given $pid is currently created in TCEforms.
+	 * This information is required for conditions in BE for PIDupinRootline.
+	 * 
+	 * @param	integer		$pid: The pid the check for as parent page
+	 * @return	boolean		true if the is currently a new page record being edited with $pid as uid of the parent page
+	 */
+	protected function isNewPageWithPid($pid) {
+		if (isset($GLOBALS['SOBE']) && $GLOBALS['SOBE'] instanceof SC_alt_doc) {
+			$pid = intval($pid);
+			$elementsData = $GLOBALS['SOBE']->elementsData;
+			$data = $GLOBALS['SOBE']->data;
+				// If editing a new page record:
+			if (is_array($elementsData)) {
+				foreach ($elementsData as $element) {
+					if ($element['cmd'] == 'new' && $element['table'] == 'pages') {
+						if ($element['pid'] < 0) {
+							$pageRecord = t3lib_BEfunc::getRecord('pages', abs($element['pid']), 'pid');
+							$element['pid'] = $pageRecord['pid'];
+						}
+						if ($element['pid'] == $pid) {
+							return true;
+						}
+					}
+				}
+				// If saving a new page record:
+			} elseif (is_array($data) && isset($data['pages']) && is_array($data['pages'])) {
+				foreach ($data['pages'] as $uid => $fields) {
+					if (substr($uid, 0, 3) == 'NEW' && $fields['pid'] == $pid) {
+						return true;
+					}
+				}
+			}
+		}
+		return false;
+	}
+
+	/**
+	 * Get the rootline for the current page.
+	 *
+	 * @return	array		The rootline for the current page.
+	 */
+	protected function getRootline() {
+		$pageId = $this->getPageId();
+		$rootline = t3lib_BEfunc::BEgetRootLine($pageId, '', true);
+		return $rootline;
+	}
+
+	/**
+	 * Get prefix for user functions (normally 'user_').
+	 *
+	 * @return	string		The prefix for user functions (normally 'user_').
+	 */
+	protected function getUserFuncClassPrefix() {
+		$userFuncClassPrefix = 'user_';
+		return $userFuncClassPrefix;
+	}
+
+	/**
+	 * Get the id of the current user.
+	 *
+	 * @return	integer		The id of the current user
+	 */
+	protected function getUserId() {
+		$userId = $GLOBALS['BE_USER']->user['uid'];
+		return $userId;
+	}
+
+	/**
+	 * Determines if a user is logged in.
+	 *
+	 * @return	boolean		Determines if a user is logged in
+	 */
+	protected function isUserLoggedIn() {
+		$userLoggedIn = false;
+		if ($GLOBALS['BE_USER']->user['uid']) {
+			$userLoggedIn = true;
+		}
+		return $userLoggedIn;
+	}
+
+	/**
+	 * Set/write a log message.
+	 *
+	 * @param	string		$message: The log message to set/write
+	 * @return	void
+	 */
+	protected function log($message) {
+		if (is_object($GLOBALS['BE_USER'])) {
+			$GLOBALS['BE_USER']->writelog(3, 0, 1, 0, $message, array());
+		}
+	}
+}
+
+
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/matchcondition/class.t3lib_matchcondition_frontend.php'])	{
+	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/matchcondition/class.t3lib_matchcondition_frontend.php']);
+}
+
+?>
\ No newline at end of file
Index: t3lib/matchcondition/class.t3lib_matchcondition_frontend.php
===================================================================
--- t3lib/matchcondition/class.t3lib_matchcondition_frontend.php	(Revision 0)
+++ t3lib/matchcondition/class.t3lib_matchcondition_frontend.php	(Revision 0)
@@ -0,0 +1,188 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 2009 Oliver Hader <oliver@typo3.org>
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+/**
+ * Matching TypoScript conditions for frontend disposal.
+ *
+ * Used with the TypoScript parser.
+ * Matches browserinfo, IPnumbers for use with templates
+ *
+ * @author	Kasper Skaarhoj <kasperYYYY@typo3.com>
+ * @package TYPO3
+ * @subpackage t3lib
+ */
+class t3lib_matchCondition_frontend extends t3lib_matchCondition_abstract {
+	/**
+	 * Constructor for this class
+	 *
+	 * @return	void
+	 */
+	function __construct() {
+	}
+
+	/**
+	 * Evaluates a TypoScript condition given as input, eg. "[browser=net][...(other conditions)...]"
+	 *
+	 * @param	string		The condition to match against its criterias.
+	 * @return	boolean		Returns true or false based on the evaluation.
+	 * @see t3lib_tsparser::parse()
+	 */
+	protected function evaluateCondition($string) {
+		list($key, $value) = t3lib_div::trimExplode('=', $string, false, 2);
+
+		$result = parent::evaluateConditionCommon($key, $value);
+
+		if (is_bool($result)) {
+			return $result;
+		} else {
+			switch ($key) {
+				case 'treeLevel':
+					$values = t3lib_div::trimExplode(',', $value, true);
+					$treeLevel = count($this->rootline) - 1;
+					foreach ($values as $test) {
+						if ($test == $treeLevel) {
+							return true;
+						}
+					}
+				break;
+				case 'PIDupinRootline':
+				case 'PIDinRootline':
+					$values = t3lib_div::trimExplode(',', $value, true);
+					if (($key=='PIDinRootline') || (!in_array($this->pageId, $values))) {
+						foreach ($values as $test) {
+							foreach ($this->rootline as $rl_dat) {
+								if ($rl_dat['uid'] == $test) {
+									return true;
+								}
+							}
+						}
+					}
+				break;
+			}
+		}
+
+		return false;
+	}
+
+	/**
+	 * Returns GP / ENV / TSFE vars
+	 *
+	 * @param	string		Identifier
+	 * @return	mixed		The value of the variable pointed to.
+	 */
+	protected function getVariable($var) {
+		$vars = explode(':', $var, 2);
+
+		$val = parent::getVariableCommon($vars);
+
+		if (is_null($val)) {
+			$splitAgain=explode('|', $vars[1], 2);
+			$k = trim($splitAgain[0]);
+			if ($k) {
+				switch((string)trim($vars[0])) {
+					case 'TSFE':
+						$val = $this->getGlobal('TSFE|' . $vars[1]);
+					break;
+				}
+			}
+		}
+
+		return $val;
+	}
+
+	/**
+	 * Get the usergroup list of the current user.
+	 *
+	 * @return	string		The usergroup list of the current user
+	 */
+	protected function getGroupList() {
+		$groupList = $GLOBALS['TSFE']->gr_list;
+		return $groupList;
+	}
+
+	/**
+	 * Get the rootline for the current page.
+	 *
+	 * @return	array		The rootline for the current page.
+	 */
+	protected function getRootline() {
+		$rootline = $GLOBALS['TSFE']->tmpl->rootLine;
+		return $rootline;
+	}
+
+	/**
+	 * Get prefix for user functions (normally 'user_').
+	 *
+	 * @return	string		The prefix for user functions (normally 'user_').
+	 */
+	protected function getUserFuncClassPrefix() {
+		$userFuncClassPrefix = $GLOBALS['TSFE']->TYPO3_CONF_VARS['FE']['userFuncClassPrefix'];
+		return $userFuncClassPrefix;
+	}
+
+	/**
+	 * Get the id of the current user.
+	 *
+	 * @return	integer		The id of the current user
+	 */
+	protected function getUserId() {
+		$userId = $GLOBALS['TSFE']->fe_user->user['uid'];
+		return $userId;
+	}
+
+	/**
+	 * Determines if a user is logged in.
+	 *
+	 * @return	boolean		Determines if a user is logged in
+	 */
+	protected function isUserLoggedIn() {
+		$userLoggedIn = false;
+		if ($GLOBALS['TSFE']->loginUser) {
+			$userLoggedIn = true;
+		}
+		return $userLoggedIn;
+	}
+
+	/**
+	 * Set/write a log message.
+	 *
+	 * @param	string		$message: The log message to set/write
+	 * @return	void
+	 */
+	protected function log($message) {
+		if (is_object($GLOBALS['TT'])) {
+			$GLOBALS['TT']->setTSlogMessage($message,3);
+		}
+	}
+}
+
+
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/matchcondition/class.t3lib_matchcondition_frontend.php'])	{
+	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/matchcondition/class.t3lib_matchcondition_frontend.php']);
+}
+
+?>
\ No newline at end of file
Index: t3lib/matchcondition/class.t3lib_matchcondition_abstract.php
===================================================================
--- t3lib/matchcondition/class.t3lib_matchcondition_abstract.php	(Revision 0)
+++ t3lib/matchcondition/class.t3lib_matchcondition_abstract.php	(Revision 0)
@@ -0,0 +1,605 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 2009 Oliver Hader <oliver@typo3.org>
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+/**
+ * Matching TypoScript conditions
+ *
+ * $Id$
+ *
+ * Used with the TypoScript parser.
+ * Matches browserinfo, IPnumbers for use with templates
+ *
+ * @author	Oliver Hader <oliver@typo3.org>
+ * @package TYPO3
+ * @subpackage t3lib
+ */
+abstract class t3lib_matchCondition_abstract {
+	protected $pageId;
+	protected $rootline = array();
+
+	protected $simulateMatchResult;
+	protected $simulateMatchConditions;
+
+	/**
+	 * Sets the id of the page to evaluate conditions for.
+	 *
+	 * @param	integer		$pageId: Id of the page
+	 * @return	void
+	 */
+	public function setPageId($pageId) {
+		$this->pageId = (int)$pageId;
+	}
+
+	/**
+	 * Sets the rootline.
+	 *
+	 * @param	array		$rootline: The rootline to be used for matching
+	 * @return	void
+	 */
+	public function setRootline(array $rootline) {
+		$this->rootline = $rootline;
+	}
+
+	public function setSimulateMatchResult($simulateMatchResult = NULL) {
+		if (is_bool($simulateMatchResult)) {
+			$this->simulateMatchResult = $simulateMatchResult;
+		} elseif (is_null($simulateMatchResult)) {
+			unset($this->simulateMatchResult);
+		}
+	}
+
+	public function setSimulateMatchConditions(array $simulateMatchConditions = NULL) {
+		if (is_bool($simulateMatchConditions)) {
+			$this->simulateMatchConditions = $simulateMatchConditions;
+		} elseif (is_null($simulateMatchConditions)) {
+			unset($this->simulateMatchConditions);
+		}
+	}
+
+	/**
+	 * Normalizes an expression and removes the first and last square bracket.
+	 *  + OR normalization: "...]OR[...", "...]||[...", "...][..." --> "...]||[..."
+	 *  + AND normalization: "...]AND[...", "...]&&[..."           --> "...]&&[..."
+	 *
+	 * @param	string		$expression: The expression to be normalized (e.g. "[A] && [B] OR [C]")
+	 * @return	string		The normalized expression (e.g. "[A]&&[B]||[C]")
+	 */
+	protected function normalizeExpression($expression) {
+		$normalizedExpression = preg_replace(
+			array(
+				'/\]\s*(OR|\|\|)?\s*\[/i',
+				'/\]\s*(AND|&&)\s*\[/i',
+			),
+			array(
+				']||[',
+				']&&[',
+			),
+			trim($expression)
+		);
+
+		return $normalizedExpression;
+	}
+
+	/**
+	 * Matches a TypoScript condition expression.
+	 *
+	 * @param	string		$expression: The expression to match
+	 * @return	boolean		Whether the expression matched
+	 */
+	public function match($expression) {
+			// Return directly if result should be simulated:
+		if (isset($this->simulateMatchResult)) {
+			return $this->simulateMatchResult;
+		}
+			// Return directly if matching for specific condition is simulated only:
+		if (isset($this->simulateMatchConditions)) {
+			return in_array($expression, $this->simulateMatchConditions);
+		}
+			// Sets the rootline if not defined yet:
+		if (!isset($this->rootline)) {
+			$this->setRootline(
+				$this->getRootline()
+			);
+		}
+
+		$result = false;
+		$normalizedExpression = $this->normalizeExpression($expression);
+
+			// First and last character must be square brackets (e.g. "[A]&&[B]":
+		if (substr($normalizedExpression, 0, 1) === '[' && substr($normalizedExpression, -1) === ']') {
+			$innerExpression = substr($normalizedExpression, 1, -1);
+
+			$orParts = explode(']||[', $innerExpression);
+			foreach ($orParts as $orPart) {
+				$andParts = explode(']&&[', $orPart);
+				foreach ($andParts as $andPart) {
+					$result = $this->evaluateCondition($andPart);
+						// If condition in AND context fails, the whole block is false:
+					if ($result === false) {
+						break;
+					}
+				}
+					// If condition in OR context succeeds, the whole expression is true:
+				if ($result === true) {
+					break;
+				}
+			}
+		}
+
+		return $result;
+	}
+
+	/**
+	 * Evaluates a TypoScript condition given as input, eg. "[browser=net][...(other conditions)...]"
+	 *
+	 * @param	string		The condition to match against its criterias.
+	 * @return	mixed		Returns true or false based on the evaluation 
+	 */
+	protected function evaluateConditionCommon($key, $value) {
+		if (t3lib_div::inList('browser,version,system,useragent', strtolower($key))) {
+			$browserInfo = t3lib_utility_client::getBrowserInfo(t3lib_div::getIndpEnv('HTTP_USER_AGENT'));
+		}
+
+		switch ($key) {
+			case 'browser':
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					if (strpos($browserInfo['browser'] . $browserInfo['version'], $test) !== false) {
+						return true;
+					}
+				}
+			break;
+			case 'version':
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					if (strcspn($test, '=<>') == 0) {
+						switch (substr($test, 0, 1)) {
+							case '=':
+								if (doubleval(substr($test, 1)) == $browserInfo['version']) {
+									return true;
+								}
+							break;
+							case '<':
+								if (doubleval(substr($test, 1)) > $browserInfo['version']) {
+									return true;
+								}
+							break;
+							case '>':
+								if (doubleval(substr($test, 1)) < $browserInfo['version']) {
+									return true;
+								}
+							break;
+						}
+					} else {
+						if (strpos(' ' . $browserInfo['version'], $test) == 1) {
+							return true;
+						}
+					}
+				}
+			break;
+			case 'system':
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					if (strpos(' ' . $browserInfo['system'], $test) == 1) {
+						return true;
+					}
+				}
+			break;
+			case 'device':
+				if (!isset($this->deviceInfo)) {
+					$this->deviceInfo = $this->whichDevice(t3lib_div::getIndpEnv('HTTP_USER_AGENT'));
+				}
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					if ($this->deviceInfo == $test) {
+						return true;
+					}
+				}
+			break;
+			case 'useragent':
+				$test = trim($value);
+				if (strlen($test)) {
+					return $this->searchStringWildcard($browserInfo['useragent'], $test);
+				}
+			break;
+			case 'language':
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					if (preg_match('/^\*.+\*$/', $test)) {
+						$allLanguages = preg_split('/[,;]/', t3lib_div::getIndpEnv('HTTP_ACCEPT_LANGUAGE'));
+						if (in_array(substr($test, 1, -1), $allLanguages)) {
+							return true;
+						}
+					} else if (t3lib_div::getIndpEnv('HTTP_ACCEPT_LANGUAGE') == $test) {
+						return true;
+					}
+				}
+			break;
+			case 'IP':
+				if (t3lib_div::cmpIP(t3lib_div::getIndpEnv('REMOTE_ADDR'), $value)) {
+					return true;
+				}
+			break;
+			case 'hostname':
+				if (t3lib_div::cmpFQDN(t3lib_div::getIndpEnv('REMOTE_ADDR'), $value)) {
+					return true;
+				}
+			break;
+				// hour, minute, dayofweek, dayofmonth, month, year, julianday
+			case 'hour':
+			case 'minute':
+			case 'month':
+			case 'year':
+			case 'dayofweek':
+			case 'dayofmonth':
+			case 'dayofyear':
+				$theEvalTime = $GLOBALS['SIM_EXEC_TIME'];	// In order to simulate time properly in templates.
+				switch($key) {
+					case 'hour':		$theTestValue = date('H', $theEvalTime);	break;
+					case 'minute':		$theTestValue = date('i', $theEvalTime);	break;
+					case 'month':		$theTestValue = date('m', $theEvalTime);	break;
+					case 'year':		$theTestValue = date('Y', $theEvalTime);	break;
+					case 'dayofweek':	$theTestValue = date('w', $theEvalTime);	break;
+					case 'dayofmonth':	$theTestValue = date('d', $theEvalTime);	break;
+					case 'dayofyear':	$theTestValue = date('z', $theEvalTime);	break;
+				}
+				$theTestValue = intval($theTestValue);
+					// comp
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					if (t3lib_div::testInt($test)) {
+						$test = '=' . $test;
+					}
+					if ($this->compareNumber($test, $theTestValue)) {
+						return true;
+					}
+				}
+			break;
+			case 'compatVersion':
+				return t3lib_div::compat_version($value);
+			break;
+			case 'usergroup':
+				$groupList = $this->getGroupList();
+				if ($groupList != '0,-1') {		// '0,-1' is the default usergroups when not logged in!
+					$values = t3lib_div::trimExplode(',', $value, true);
+					foreach ($values as $test) {
+						if ($test == '*' || t3lib_div::inList($groupList, $test)) {
+							return true;
+						}
+					}
+				}
+			break;
+			case 'loginUser':
+				if ($this->isUserLoggedIn()) {
+					$values = t3lib_div::trimExplode(',', $value, true);
+					foreach ($values as $test) {
+						if ($test == '*' || !strcmp($this->getUserId(), $test)) {
+							return true;
+						}
+					}
+				}
+			break;
+			case 'globalVar':
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					$point = strcspn($test, '!=<>');
+					$theVarName = substr($test, 0, $point);
+					$nv = $this->getVariable(trim($theVarName));
+					$testValue = substr($test, $point);
+
+					if ($this->compareNumber($testValue, $nv)) {
+						return true;
+					}
+				}
+			break;
+			case 'globalString':
+				$values = t3lib_div::trimExplode(',', $value, true);
+				foreach ($values as $test) {
+					$point = strcspn($test, '=');
+					$theVarName = substr($test, 0, $point);
+					$nv = $this->getVariable(trim($theVarName));
+					$testValue = substr($test, $point+1);
+
+					if ($this->searchStringWildcard($nv, trim($testValue))) {
+						return true;
+					}
+				}
+			break;
+			case 'userFunc':
+				$values = preg_split('/\(|\)/', $value);
+				$funcName = trim($values[0]);
+				$funcValue = t3lib_div::trimExplode(',', $values[1]);
+				$prefix = $this->getUserFuncClassPrefix();
+				if ($prefix &&
+					!t3lib_div::isFirstPartOfStr(trim($funcName), $prefix) &&
+					!t3lib_div::isFirstPartOfStr(trim($funcName),'tx_')
+				)	{
+					$this->log('Match condition: Function "' . $funcName . '" was not prepended with "' . $pre.'"');
+					return false;
+				}
+				if (function_exists($funcName) && call_user_func($funcName, $funcValue[0]))	{
+					return true;
+				}
+			break;
+		}
+
+		return NULL;
+	}
+
+	protected function getVariableCommon(array $vars) {
+		$val = '';
+
+		if (count($vars) == 1) {
+			$val = $this->getGlobal($vars[0]);
+		} else {
+			$splitAgain = explode('|',$vars[1],2);
+			$k = trim($splitAgain[0]);
+
+			if ($k)	{
+				switch((string)trim($vars[0]))	{
+					case 'GP':
+						$val = t3lib_div::_GP($k);
+					break;
+					case 'ENV':
+						$val = getenv($k);
+					break;
+					case 'IENV':
+						$val = t3lib_div::getIndpEnv($k);
+					break;
+					case 'LIT':
+						{ return trim($vars[1]); }	// return litteral value...
+					break;
+					default:
+						return NULL;
+				}
+					// If array:
+				if (count($splitAgain)>1)	{
+					if (is_array($val) && trim($splitAgain[1]))	{
+						$val=$this->getGlobal($splitAgain[1],$val);
+					} else {
+						$val='';
+					}
+				}
+			}
+		}
+
+		return $val;
+	}
+
+	/**
+	 * Evaluates a $leftValue based on an operator: "<", ">", "<=", ">=", "!=" or "="
+	 *
+	 * @param	string		$test: The value to compare with on the form [operator][number]. Eg. "< 123"
+	 * @param	integer		$leftValue: The value on the left side
+	 * @return	boolean		If $value is "50" and $test is "< 123" then it will return true.
+	 */
+	protected function compareNumber($test, $leftValue) {
+		if (preg_match('/^(!?=+|<=?|>=?)\s*([^\s]*)\s*$/', $test, $matches)) {
+			$operator = $matches[1];
+			$rightValue = $matches[2];
+
+			switch ($operator) {
+				case '>=':
+					return ($leftValue >= doubleval($rightValue));
+					break;
+				case '<=':
+					return ($leftValue <= doubleval($rightValue));
+					break;
+				case '!=':
+					return ($leftValue != doubleval($rightValue));
+					break;
+				case '<':
+					return ($leftValue < doubleval($rightValue));
+					break;
+				case '>':
+					return ($leftValue > doubleval($rightValue));
+					break;
+				default:
+					// nothing valid found except '=', use '='
+					return ($leftValue == trim($rightValue));
+					break;
+			}
+		}
+
+		return false;
+	}
+
+	/**
+	 * Matching two strings against each other, supporting a "*" wildcard or (if wrapped in "/") PCRE regular expressions
+	 *
+	 * @param	string		The string in which to find $needle.
+	 * @param	string		The string to find in $haystack
+	 * @return	boolean		Returns true if $needle matches or is found in (according to wildcards) in $haystack. Eg. if $haystack is "Netscape 6.5" and $needle is "Net*" or "Net*ape" then it returns true.
+	 */
+	protected function searchStringWildcard($haystack, $needle) {
+		$result = false;
+
+		if ($needle) {
+			if (preg_match('/^\/.+\/$/', $needle)) {
+				// Regular expression, only "//" is allowed as delimiter
+				$regex = $needle;
+			} else {
+				$needle = str_replace(array('*', '?'), array('###MANY###', '###ONE###'), $needle);
+				$regex = '/^' . preg_quote($needle, '/') . '$/';
+				// Replace the marker with .* to match anything (wildcard)
+				$regex = str_replace(array('###MANY###', '###ONE###'), array('.*' , '.'), $regex);
+			}
+
+			$result = (boolean)preg_match($regex, (string)$haystack);
+		}
+
+		return $result;
+	}
+
+	/**
+	 * Returns a code for a browsing device based on the input useragent string
+	 *
+	 * @param	string		User agent string from browser, t3lib_div::getIndpEnv('HTTP_USER_AGENT')
+	 * @return	string		A code. See link.
+	 */
+	protected function getDeviceType($useragent) {
+		foreach($this->hookObjectsArr as $hookObj)	{
+			if (method_exists($hookObj, 'whichDevice')) {
+				$result = $hookObj->whichDevice($useragent);
+				if (strlen($result)) {
+					return $result;
+				}
+			}
+		}
+
+		// deprecated, see above
+		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_matchcondition.php']['devices_class']))	{
+			foreach($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_matchcondition.php']['devices_class'] as $_classRef)	{
+				$_procObj = &t3lib_div::getUserObj($_classRef);
+				return $_procObj->whichDevice_ext($useragent);
+			}
+		}
+		//
+
+		$agent=strtolower(trim($useragent));
+			// pda
+		if(	strstr($agent, 'avantgo'))	{
+			return 'pda';
+		}
+
+			// wap
+		$browser=substr($agent,0,4);
+		$wapviwer=substr(stristr($agent,'wap'),0,3);
+		if(	$wapviwer=='wap' ||
+			$browser=='noki' ||
+			$browser== 'eric' ||
+			$browser== 'r380' ||
+			$browser== 'up.b' ||
+			$browser== 'winw' ||
+			$browser== 'wapa')	{
+				return 'wap';
+		}
+
+			// grabber
+		if(	strstr($agent, 'g.r.a.b.') ||
+			strstr($agent, 'utilmind httpget') ||
+			strstr($agent, 'webcapture') ||
+			strstr($agent, 'teleport') ||
+			strstr($agent, 'webcopier'))	{
+			return 'grabber';
+		}
+
+			// robots
+		if(	strstr($agent, 'crawler') ||
+			strstr($agent, 'spider') ||
+			strstr($agent, 'googlebot') ||
+			strstr($agent, 'searchbot') ||
+			strstr($agent, 'infoseek') ||
+			strstr($agent, 'altavista') ||
+			strstr($agent, 'diibot'))	{
+			return 'robot';
+		}
+
+	}
+
+	/**
+	 * Return global variable where the input string $var defines array keys separated by "|"
+	 * Example: $var = "HTTP_SERVER_VARS | something" will return the value $GLOBALS['HTTP_SERVER_VARS']['something'] value
+	 *
+	 * @param	string		Global var key, eg. "HTTP_GET_VAR" or "HTTP_GET_VARS|id" to get the GET parameter "id" back.
+	 * @param	array		Alternative array than $GLOBAL to get variables from.
+	 * @return	mixed		Whatever value. If none, then blank string.
+	 */
+	protected function getGlobal($var, $source=NULL) {
+		$vars = explode('|', $var);
+		$c = count($vars);
+		$k = trim($vars[0]);
+		$theVar = isset($source) ? $source[$k] : $GLOBALS[$k];
+
+		for ($a=1;$a<$c;$a++)	{
+			if (!isset($theVar))	{ break; }
+
+			$key = trim($vars[$a]);
+			if (is_object($theVar)) {
+				$theVar = $theVar->$key;
+			} elseif (is_array($theVar)) {
+				$theVar = $theVar[$key];
+			} else {
+				return '';
+			}
+		}
+
+		if (!is_array($theVar) && !is_object($theVar))	{
+			return $theVar;
+		} else {
+			return '';
+		}
+	}
+
+	abstract protected function evaluateCondition($string);
+
+	abstract protected function getVariable($name);
+
+	/**
+	 * Gets the usergroup list of the current user.
+	 *
+	 * @return	string		The usergroup list of the current user
+	 */
+	abstract protected function getGroupList();
+
+	/**
+	 * Gets the rootline for the current page.
+	 *
+	 * @return	array		The rootline for the current page.
+	 */
+	abstract protected function getRootline();
+
+	/**
+	 * Gets prefix for user functions (normally 'user_').
+	 *
+	 * @return	string		The prefix for user functions (normally 'user_').
+	 */
+	abstract protected function getUserFuncClassPrefix();
+
+	/**
+	 * Hybrid FE/BE: Get the id of the current user.
+	 *
+	 * @return	integer		The id of the current user
+	 */
+	abstract protected function getUserId();
+
+	/**
+	 * Determines if a user is logged in.
+	 *
+	 * @return	boolean		Determines if a user is logged in
+	 */
+	abstract protected function isUserLoggedIn();
+
+	/**
+	 * Sets a log message.
+	 *
+	 * @param	string		$message: The log message to set/write
+	 * @return	void
+	 */
+	abstract protected function log($message);
+}
+
+?>
\ No newline at end of file
Index: t3lib/class.t3lib_userauthgroup.php
===================================================================
--- t3lib/class.t3lib_userauthgroup.php	(Revision 6107)
+++ t3lib/class.t3lib_userauthgroup.php	(Arbeitskopie)
@@ -1160,19 +1160,30 @@
 				// Check include lines.
 			$this->TSdataArray = t3lib_TSparser::checkIncludeLines_array($this->TSdataArray);
 
-				// Parsing the user TSconfig (or getting from cache)
 			$this->userTS_text = implode(chr(10).'[GLOBAL]'.chr(10),$this->TSdataArray);	// Imploding with "[global]" will make sure that non-ended confinements with braces are ignored.
-			$hash = md5('userTS:'.$this->userTS_text);
-			$cachedContent = t3lib_BEfunc::getHash($hash);
-			if (isset($cachedContent) && !$this->userTS_dontGetCached)	{
-				$this->userTS = unserialize($cachedContent);
+
+			if ($GLOBALS['TYPO3_CONF_VARS']['BE']['TSconfigConditions'] && !$this->userTS_dontGetCached) {
+					// Perform TS-Config parsing with condition matching
+				$parseObj = t3lib_div::makeInstance('t3lib_TSparser_TSconfig');
+				$res = $parseObj->parseTSconfig($this->userTS_text, false, false, 'userTS');
+				if ($res) {
+					$this->userTS = $res['TSconfig'];
+					$this->userTSUpdated = ($res['cached'] ? 0 : 1);
+				}
 			} else {
-				$parseObj = t3lib_div::makeInstance('t3lib_TSparser');
-				$parseObj->parse($this->userTS_text);
-				$this->userTS = $parseObj->setup;
-				t3lib_BEfunc::storeHash($hash,serialize($this->userTS),'BE_USER_TSconfig');
-					// Update UC:
-				$this->userTSUpdated=1;
+					// Parsing the user TSconfig (or getting from cache)
+				$hash = md5('userTS:' . $this->userTS_text);
+				$cachedContent = t3lib_BEfunc::getHash($hash);
+				if (isset($cachedContent) && !$this->userTS_dontGetCached) {
+					$this->userTS = unserialize($cachedContent);
+				} else {
+					$parseObj = t3lib_div::makeInstance('t3lib_TSparser');
+					$parseObj->parse($this->userTS_text);
+					$this->userTS = $parseObj->setup;
+					t3lib_BEfunc::storeHash($hash, serialize($this->userTS), 'BE_USER_TSconfig');
+						// Update UC:
+					$this->userTSUpdated=1;
+				}
 			}
 
 				// Processing webmounts
Index: t3lib/class.t3lib_tsparser_ext.php
===================================================================
--- t3lib/class.t3lib_tsparser_ext.php	(Revision 6107)
+++ t3lib/class.t3lib_tsparser_ext.php	(Arbeitskopie)
@@ -292,8 +292,9 @@
 		$constants->setup = $this->const;
 		$constants->setup = $this->mergeConstantsFromPageTSconfig($constants->setup);
 
-		$matchObj = t3lib_div::makeInstance('t3lib_matchCondition');
-		$matchObj->matchAll=1;		// Matches ALL conditions in TypoScript
+		/* @var $matchObj t3lib_matchCondition_frontend */
+		$matchObj = t3lib_div::makeInstance('t3lib_matchCondition_frontend');
+		$matchObj->setSimulateMatchResult(true);	// Matches ALL conditions in TypoScript
 
 		$c=0;
 		$cc=count($this->constants);
